Index: validation/DelphesValidation.cpp
===================================================================
--- validation/DelphesValidation.cpp	(revision 5107603364acdad8e994549206002d7247bab770)
+++ validation/DelphesValidation.cpp	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
@@ -2326,694 +2272,677 @@
   TCanvas *c_pfjet_res_eta[n_ptbins];
 
-
   // loop over eta bins
-  for (k = 0; k < etaVals.size()-1; k++)
-  {
-
-     mg_pfjet_res_e[k] = new TMultiGraph("","");
-     leg_pfjet_res_e[k] = new TLegend(0.40,0.70,0.90,0.90);
-
-     HistogramsCollection(&plots_pfjet_res_e[k], TMath::Log10(ptMin), TMath::Log10(ptMax), "pfjet");
-     HistogramsCollection(&plots_cajet_res_e[k], TMath::Log10(ptMin), TMath::Log10(ptMax), "cajet");
-
-     GetJetsEres(&plots_pfjet_res_e[k], branchPFJet, branchGenJet, treeReaderJet, etaVals.at(k), etaVals.at(k+1));
-     GetJetsEres(&plots_cajet_res_e[k], branchCaloJet, branchGenJet, treeReaderJet, etaVals.at(k), etaVals.at(k+1));
-
-     gr_pfjet_res_e[k] = EresGraph(&plots_pfjet_res_e[k]);
-     gr_cajet_res_e[k] = EresGraph(&plots_cajet_res_e[k]);
-
-     s_etaMin = Form("%.1f",etaVals.at(k));
-     s_etaMax = Form("%.1f",etaVals.at(k+1));
-     s_eta    = "anti-k_{T},  R = 0.4,  "+ s_etaMin + " < | #eta | < " + s_etaMax;
-
-     leg_pfjet_res_e[k]->SetTextFont(132);
-     leg_pfjet_res_e[k]->SetHeader(s_eta);
-
-     addResoGraph(mg_pfjet_res_e[k], &gr_cajet_res_e[k], leg_pfjet_res_e[k], markerStyles.at(0), colors.at(0), "Calorimeter Jets");
-     addResoGraph(mg_pfjet_res_e[k], &gr_pfjet_res_e[k], leg_pfjet_res_e[k], markerStyles.at(1), colors.at(1), "Particle-flow Jets");
-
-     c_pfjet_res_e[k] = new TCanvas("","", 800, 600);
-
-     mg_pfjet_res_e[k]->Draw("APE");
-     //DrawAxis(mg_pfjet_res_e[k], leg_pfjet_res_e[k], 10, ptMax, 0.5, 100, "E [GeV]", "(resolution in E)/E (%)", true, true);
-     DrawAxis(mg_pfjet_res_e[k], leg_pfjet_res_e[k], 10, ptMax, 0.0, 30, "E [GeV]", "(resolution in E)/E (%)", true, false);
-     leg_pfjet_res_e[k]->Draw();
-     pave->Draw();
-
-     TString s_etarange = "eta_"+s_etaMin+"_"+s_etaMax+"_";
-
-     c_pfjet_res_e[k]->Print(pdfOutput,"pdf");
-     c_pfjet_res_e[k]->Print(figPath+"img_pfjet_res_"+s_etarange+"e.pdf","pdf");
-     c_pfjet_res_e[k]->Print(figPath+"img_pfjet_res_"+s_etarange+"e.png","png");
-
-  }
-
-
-    // loop over eta bins
-  for (k = 0; k < ptVals.size(); k++)
-  {
-
-     mg_pfjet_res_eta[k] = new TMultiGraph("","");
-     leg_pfjet_res_eta[k] = new TLegend(0.30,0.70,0.85,0.90);
-
-     HistogramsCollectionVsEta(&plots_pfjet_res_eta[k], etaMin, etaMax, 0.5*ptVals.at(k), 2.0*ptVals.at(k), "pfjet", 0.0, 2.0);
-     HistogramsCollectionVsEta(&plots_cajet_res_eta[k], etaMin, etaMax, 0.5*ptVals.at(k), 2.0*ptVals.at(k), "cajet", 0.0, 2.0);
-
-     GetJetsEresVsEta(&plots_pfjet_res_eta[k], branchPFJet, branchGenJet, treeReaderJet, 0.5*ptVals.at(k), 2.0*ptVals.at(k));
-     GetJetsEresVsEta(&plots_cajet_res_eta[k], branchCaloJet, branchGenJet, treeReaderJet, 0.5*ptVals.at(k), 2.0*ptVals.at(k));
-
-     gr_pfjet_res_eta[k] = EresGraphVsEta(&plots_pfjet_res_eta[k]);
-     gr_cajet_res_eta[k] = EresGraphVsEta(&plots_cajet_res_eta[k]);
-
-     s_e = Form("anti-k_{T},  R = 0.4,  jets, E = %.0f GeV",ptVals.at(k));
-     if(ptVals.at(k) >= 1000.) s_e = Form("anti-k_{T},  R = 0.4,  E = %.0f TeV",ptVals.at(k)/1000.);
-
-     leg_pfjet_res_eta[k]->SetTextFont(132);
-     leg_pfjet_res_eta[k]->SetHeader(s_e);
-
-     addResoGraph(mg_pfjet_res_eta[k], &gr_cajet_res_eta[k], leg_pfjet_res_eta[k], markerStyles.at(0), colors.at(0), "Calorimeter Jets");
-     addResoGraph(mg_pfjet_res_eta[k], &gr_pfjet_res_eta[k], leg_pfjet_res_eta[k], markerStyles.at(1), colors.at(1), "Particle-flow Jets");
-
-     c_pfjet_res_eta[k] = new TCanvas("","", 800, 600);
-
-     mg_pfjet_res_eta[k]->Draw("APE");
-     //DrawAxis(mg_pfjet_res_eta[k], leg_pfjet_res_eta[k], etaMin, etaMax, 0.1, 1000, "#eta", "(resolution in E)/E (%)", false, true);
-     DrawAxis(mg_pfjet_res_eta[k], leg_pfjet_res_eta[k], etaMin, etaMax, 0.0, 50, "#eta", "(resolution in E)/E (%)", false, false);
-     leg_pfjet_res_eta[k]->Draw();
-     pave->Draw();
-
-     TString s_ptrange = Form("pt_%.0f_",ptVals.at(k));
-
-     c_pfjet_res_eta[k]->Print(pdfOutput,"pdf");
-     c_pfjet_res_eta[k]->Print(figPath+"img_pfjet_res_"+s_ptrange+"eta.pdf","pdf");
-     c_pfjet_res_eta[k]->Print(figPath+"img_pfjet_res_"+s_ptrange+"eta.png","png");
-
-  }
-
-
-    /////////////////////
-    // PF Missing ET  ///
-    /////////////////////
-
-    TMultiGraph *mg_met_res_ht = new TMultiGraph("","");
-    TLegend *leg_met_res_ht    = new TLegend(0.60,0.22,0.90,0.42);
-
-    std::vector<resolPlot> plots_pfmet, plots_camet;
-
-    HistogramsCollection(&plots_pfmet, TMath::Log10(ptMin), TMath::Log10(ptMax), "pfMET", -500, 500);
-    HistogramsCollection(&plots_camet, TMath::Log10(ptMin), TMath::Log10(ptMax), "caMET", -500, 500);
-
-    GetMetres(&plots_pfmet, branchGenScalarHT, branchMet, branchPFJet, treeReaderJet);
-    GetMetres(&plots_camet, branchGenScalarHT, branchCaloMet, branchCaloJet, treeReaderJet);
-
-    TGraphErrors gr_pfmet_res_ht = MetResGraph(&plots_pfmet, true);
-    TGraphErrors gr_camet_res_ht = MetResGraph(&plots_camet, true);
-
-    addResoGraph(mg_met_res_ht, &gr_camet_res_ht, leg_met_res_ht, markerStyles.at(0), colors.at(0), "Calorimeter E_{T}^{miss}");
-    addResoGraph(mg_met_res_ht, &gr_pfmet_res_ht, leg_met_res_ht, markerStyles.at(1), colors.at(1), "Particle-flow E_{T}^{miss}");
-
-    TCanvas *c_met_res_ht = new TCanvas("","", 800, 600);
-
-    mg_met_res_ht->Draw("APE");
-    DrawAxis(mg_met_res_ht, leg_met_res_ht, 1000, 100000, 0.1, 1000, " #sum p_{T} [GeV]", "resolution in E_{x,y}^{miss} [GeV]", true, true);
-
-    leg_met_res_ht->Draw();
+  for(k = 0; k < etaVals.size() - 1; k++)
+  {
+
+    mg_pfjet_res_e[k] = new TMultiGraph("", "");
+    leg_pfjet_res_e[k] = new TLegend(0.40, 0.70, 0.90, 0.90);
+
+    HistogramsCollection(&plots_pfjet_res_e[k], TMath::Log10(ptMin), TMath::Log10(ptMax), "pfjet");
+    HistogramsCollection(&plots_cajet_res_e[k], TMath::Log10(ptMin), TMath::Log10(ptMax), "cajet");
+
+    GetJetsEres(&plots_pfjet_res_e[k], branchPFJet, branchGenJet, treeReaderJet, etaVals.at(k), etaVals.at(k + 1));
+    GetJetsEres(&plots_cajet_res_e[k], branchCaloJet, branchGenJet, treeReaderJet, etaVals.at(k), etaVals.at(k + 1));
+
+    gr_pfjet_res_e[k] = EresGraph(&plots_pfjet_res_e[k]);
+    gr_cajet_res_e[k] = EresGraph(&plots_cajet_res_e[k]);
+
+    s_etaMin = Form("%.1f", etaVals.at(k));
+    s_etaMax = Form("%.1f", etaVals.at(k + 1));
+    s_eta = "anti-k_{T},  R = 0.4,  " + s_etaMin + " < | #eta | < " + s_etaMax;
+
+    leg_pfjet_res_e[k]->SetTextFont(132);
+    leg_pfjet_res_e[k]->SetHeader(s_eta);
+
+    addResoGraph(mg_pfjet_res_e[k], &gr_cajet_res_e[k], leg_pfjet_res_e[k], markerStyles.at(0), colors.at(0), "Calorimeter Jets");
+    addResoGraph(mg_pfjet_res_e[k], &gr_pfjet_res_e[k], leg_pfjet_res_e[k], markerStyles.at(1), colors.at(1), "Particle-flow Jets");
+
+    c_pfjet_res_e[k] = new TCanvas("", "", 800, 600);
+
+    mg_pfjet_res_e[k]->Draw("APE");
+    //DrawAxis(mg_pfjet_res_e[k], leg_pfjet_res_e[k], 10, ptMax, 0.5, 100, "E [GeV]", "(resolution in E)/E (%)", true, true);
+    DrawAxis(mg_pfjet_res_e[k], leg_pfjet_res_e[k], 10, ptMax, 0.0, 30, "E [GeV]", "(resolution in E)/E (%)", true, false);
+    leg_pfjet_res_e[k]->Draw();
     pave->Draw();
-    c_met_res_ht->Print(pdfOutput,"pdf");
-    c_met_res_ht->Print(figPath+"img_met_res_ht.pdf","pdf");
-    c_met_res_ht->Print(figPath+"img_met_res_ht.png","png");
-
-
-    /////////////////////////////////////////
-    // Electron Reconstruction Efficiency ///
-    /////////////////////////////////////////
-
-    TMultiGraph *mg_recele_eff_pt  = new TMultiGraph("","");
-    TMultiGraph *mg_recele_eff_eta = new TMultiGraph("","");
-
-    TLegend *leg_recele_eff_pt  = new TLegend(0.55,0.22,0.90,0.48);
-    TLegend *leg_recele_eff_eta = new TLegend(0.55,0.22,0.90,0.48);
-
-    TGraphErrors *gr_recele_eff_pt  = new TGraphErrors[n_etabins];
-    TGraphErrors *gr_recele_eff_eta = new TGraphErrors[n_ptbins];
-    TH1D* h_recele_eff_pt, *h_recele_eff_eta;
-
-    // loop over eta bins
-    for (k = 0; k < etaVals.size()-1; k++)
+
+    TString s_etarange = "eta_" + s_etaMin + "_" + s_etaMax + "_";
+
+    c_pfjet_res_e[k]->Print(pdfOutput, "pdf");
+    c_pfjet_res_e[k]->Print(figPath + "img_pfjet_res_" + s_etarange + "e.pdf", "pdf");
+    c_pfjet_res_e[k]->Print(figPath + "img_pfjet_res_" + s_etarange + "e.png", "png");
+  }
+
+  // loop over eta bins
+  for(k = 0; k < ptVals.size(); k++)
+  {
+
+    mg_pfjet_res_eta[k] = new TMultiGraph("", "");
+    leg_pfjet_res_eta[k] = new TLegend(0.30, 0.70, 0.85, 0.90);
+
+    HistogramsCollectionVsEta(&plots_pfjet_res_eta[k], etaMin, etaMax, 0.5 * ptVals.at(k), 2.0 * ptVals.at(k), "pfjet", 0.0, 2.0);
+    HistogramsCollectionVsEta(&plots_cajet_res_eta[k], etaMin, etaMax, 0.5 * ptVals.at(k), 2.0 * ptVals.at(k), "cajet", 0.0, 2.0);
+
+    GetJetsEresVsEta(&plots_pfjet_res_eta[k], branchPFJet, branchGenJet, treeReaderJet, 0.5 * ptVals.at(k), 2.0 * ptVals.at(k));
+    GetJetsEresVsEta(&plots_cajet_res_eta[k], branchCaloJet, branchGenJet, treeReaderJet, 0.5 * ptVals.at(k), 2.0 * ptVals.at(k));
+
+    gr_pfjet_res_eta[k] = EresGraphVsEta(&plots_pfjet_res_eta[k]);
+    gr_cajet_res_eta[k] = EresGraphVsEta(&plots_cajet_res_eta[k]);
+
+    s_e = Form("anti-k_{T},  R = 0.4,  jets, E = %.0f GeV", ptVals.at(k));
+    if(ptVals.at(k) >= 1000.) s_e = Form("anti-k_{T},  R = 0.4,  E = %.0f TeV", ptVals.at(k) / 1000.);
+
+    leg_pfjet_res_eta[k]->SetTextFont(132);
+    leg_pfjet_res_eta[k]->SetHeader(s_e);
+
+    addResoGraph(mg_pfjet_res_eta[k], &gr_cajet_res_eta[k], leg_pfjet_res_eta[k], markerStyles.at(0), colors.at(0), "Calorimeter Jets");
+    addResoGraph(mg_pfjet_res_eta[k], &gr_pfjet_res_eta[k], leg_pfjet_res_eta[k], markerStyles.at(1), colors.at(1), "Particle-flow Jets");
+
+    c_pfjet_res_eta[k] = new TCanvas("", "", 800, 600);
+
+    mg_pfjet_res_eta[k]->Draw("APE");
+    //DrawAxis(mg_pfjet_res_eta[k], leg_pfjet_res_eta[k], etaMin, etaMax, 0.1, 1000, "#eta", "(resolution in E)/E (%)", false, true);
+    DrawAxis(mg_pfjet_res_eta[k], leg_pfjet_res_eta[k], etaMin, etaMax, 0.0, 50, "#eta", "(resolution in E)/E (%)", false, false);
+    leg_pfjet_res_eta[k]->Draw();
+    pave->Draw();
+
+    TString s_ptrange = Form("pt_%.0f_", ptVals.at(k));
+
+    c_pfjet_res_eta[k]->Print(pdfOutput, "pdf");
+    c_pfjet_res_eta[k]->Print(figPath + "img_pfjet_res_" + s_ptrange + "eta.pdf", "pdf");
+    c_pfjet_res_eta[k]->Print(figPath + "img_pfjet_res_" + s_ptrange + "eta.png", "png");
+  }
+
+  /////////////////////
+  // PF Missing ET  ///
+  /////////////////////
+
+  TMultiGraph *mg_met_res_ht = new TMultiGraph("", "");
+  TLegend *leg_met_res_ht = new TLegend(0.60, 0.22, 0.90, 0.42);
+
+  std::vector<resolPlot> plots_pfmet, plots_camet;
+
+  HistogramsCollection(&plots_pfmet, TMath::Log10(ptMin), TMath::Log10(ptMax), "pfMET", -500, 500);
+  HistogramsCollection(&plots_camet, TMath::Log10(ptMin), TMath::Log10(ptMax), "caMET", -500, 500);
+
+  GetMetres(&plots_pfmet, branchGenScalarHT, branchMet, branchPFJet, treeReaderJet);
+  GetMetres(&plots_camet, branchGenScalarHT, branchCaloMet, branchCaloJet, treeReaderJet);
+
+  TGraphErrors gr_pfmet_res_ht = MetResGraph(&plots_pfmet, true);
+  TGraphErrors gr_camet_res_ht = MetResGraph(&plots_camet, true);
+
+  addResoGraph(mg_met_res_ht, &gr_camet_res_ht, leg_met_res_ht, markerStyles.at(0), colors.at(0), "Calorimeter E_{T}^{miss}");
+  addResoGraph(mg_met_res_ht, &gr_pfmet_res_ht, leg_met_res_ht, markerStyles.at(1), colors.at(1), "Particle-flow E_{T}^{miss}");
+
+  TCanvas *c_met_res_ht = new TCanvas("", "", 800, 600);
+
+  mg_met_res_ht->Draw("APE");
+  DrawAxis(mg_met_res_ht, leg_met_res_ht, 1000, 100000, 0.1, 1000, " #sum p_{T} [GeV]", "resolution in E_{x,y}^{miss} [GeV]", true, true);
+
+  leg_met_res_ht->Draw();
+  pave->Draw();
+  c_met_res_ht->Print(pdfOutput, "pdf");
+  c_met_res_ht->Print(figPath + "img_met_res_ht.pdf", "pdf");
+  c_met_res_ht->Print(figPath + "img_met_res_ht.png", "png");
+
+  /////////////////////////////////////////
+  // Electron Reconstruction Efficiency ///
+  /////////////////////////////////////////
+
+  TMultiGraph *mg_recele_eff_pt = new TMultiGraph("", "");
+  TMultiGraph *mg_recele_eff_eta = new TMultiGraph("", "");
+
+  TLegend *leg_recele_eff_pt = new TLegend(0.55, 0.22, 0.90, 0.48);
+  TLegend *leg_recele_eff_eta = new TLegend(0.55, 0.22, 0.90, 0.48);
+
+  TGraphErrors *gr_recele_eff_pt = new TGraphErrors[n_etabins];
+  TGraphErrors *gr_recele_eff_eta = new TGraphErrors[n_ptbins];
+  TH1D *h_recele_eff_pt, *h_recele_eff_eta;
+
+  // loop over eta bins
+  for(k = 0; k < etaVals.size() - 1; k++)
+  {
+
+    h_recele_eff_pt = GetEffPt<Electron>(branchElectron, branchParticleElectron, "Electron", 11, ptMin, ptMax, etaVals.at(k), etaVals.at(k + 1), treeReaderElectron);
+    gr_recele_eff_pt[k] = TGraphErrors(h_recele_eff_pt);
+
+    s_etaMin = Form("%.1f", etaVals.at(k));
+    s_etaMax = Form("%.1f", etaVals.at(k + 1));
+
+    s_eta = "e^{ #pm} , " + s_etaMin + " < | #eta | < " + s_etaMax;
+
+    gr_recele_eff_pt[k].SetName("recEff_" + s_etaMin + "_" + s_etaMax);
+
+    addResoGraph(mg_recele_eff_pt, &gr_recele_eff_pt[k], leg_recele_eff_pt, markerStyles.at(k), colors.at(k), s_eta);
+  }
+
+  // loop over pt
+  for(k = 0; k < ptVals.size(); k++)
+  {
+    h_recele_eff_eta = GetEffEta<Electron>(branchElectron, branchParticleElectron, "Electron", 11, 0.5 * ptVals.at(k), 2.0 * ptVals.at(k), etaMin, etaMax, treeReaderElectron);
+    gr_recele_eff_eta[k] = TGraphErrors(h_recele_eff_eta);
+
+    s_pt = Form("e^{ #pm} , p_{T} = %.0f GeV", ptVals.at(k));
+    if(ptVals.at(k) >= 1000.) s_pt = Form("e^{ #pm} , p_{T} = %.0f TeV", ptVals.at(k) / 1000.);
+
+    addResoGraph(mg_recele_eff_eta, &gr_recele_eff_eta[k], leg_recele_eff_eta, markerStyles.at(k), colors.at(k), s_pt);
+  }
+
+  TCanvas *c_recele_eff_pt = new TCanvas("", "", 800, 600);
+
+  mg_recele_eff_pt->Draw("APE");
+  DrawAxis(mg_recele_eff_pt, leg_recele_eff_pt, ptMin, ptMax, 0.0, 100, "p_{T} [GeV]", "reconstruction efficiency (%)", true, false);
+  leg_recele_eff_pt->Draw();
+  pave->Draw();
+
+  c_recele_eff_pt->Print(pdfOutput, "pdf");
+  c_recele_eff_pt->Print(figPath + "img_recele_eff_pt.pdf", "pdf");
+  c_recele_eff_pt->Print(figPath + "img_recele_eff_pt.png", "png");
+
+  TCanvas *c_recele_eff_eta = new TCanvas("", "", 800, 600);
+
+  mg_recele_eff_eta->Draw("APE");
+  DrawAxis(mg_recele_eff_eta, leg_recele_eff_eta, etaMin, etaMax, 0.0, 100, " #eta ", "reconstruction efficiency (%)", false, false);
+  leg_recele_eff_eta->Draw();
+  pave->Draw();
+
+  c_recele_eff_eta->Print(pdfOutput, "pdf");
+  c_recele_eff_eta->Print(figPath + "img_recele_eff_eta.pdf", "pdf");
+  c_recele_eff_eta->Print(figPath + "img_recele_eff_eta.png", "png");
+
+  /////////////////////////////////////////
+  // Muon Reconstruction Efficiency ///
+  /////////////////////////////////////////
+
+  TMultiGraph *mg_recmu_eff_pt = new TMultiGraph("", "");
+  TMultiGraph *mg_recmu_eff_eta = new TMultiGraph("", "");
+
+  TLegend *leg_recmu_eff_pt = new TLegend(0.55, 0.22, 0.90, 0.48);
+  TLegend *leg_recmu_eff_eta = new TLegend(0.55, 0.22, 0.90, 0.48);
+
+  TGraphErrors *gr_recmu_eff_pt = new TGraphErrors[n_etabins];
+  TGraphErrors *gr_recmu_eff_eta = new TGraphErrors[n_ptbins];
+  TH1D *h_recmu_eff_pt, *h_recmu_eff_eta;
+
+  // loop over eta bins
+  for(k = 0; k < etaVals.size() - 1; k++)
+  {
+
+    h_recmu_eff_pt = GetEffPt<Muon>(branchMuon, branchParticleMuon, "muon", 13, ptMin, ptMax, etaVals.at(k), etaVals.at(k + 1), treeReaderMuon);
+    gr_recmu_eff_pt[k] = TGraphErrors(h_recmu_eff_pt);
+
+    s_etaMin = Form("%.1f", etaVals.at(k));
+    s_etaMax = Form("%.1f", etaVals.at(k + 1));
+
+    s_eta = "#mu^{ #pm} , " + s_etaMin + " < | #eta | < " + s_etaMax;
+
+    gr_recmu_eff_pt[k].SetName("recEff_" + s_etaMin + "_" + s_etaMax);
+
+    addResoGraph(mg_recmu_eff_pt, &gr_recmu_eff_pt[k], leg_recmu_eff_pt, markerStyles.at(k), colors.at(k), s_eta);
+  }
+
+  // loop over pt
+  for(k = 0; k < ptVals.size(); k++)
+  {
+    h_recmu_eff_eta = GetEffEta<Muon>(branchMuon, branchParticleMuon, "muon", 13, 0.5 * ptVals.at(k), 2.0 * ptVals.at(k), etaMin, etaMax, treeReaderMuon);
+    gr_recmu_eff_eta[k] = TGraphErrors(h_recmu_eff_eta);
+
+    s_pt = Form("#mu^{ #pm} , p_{T} = %.0f GeV", ptVals.at(k));
+    if(ptVals.at(k) >= 1000.) s_pt = Form("#mu^{ #pm} , p_{T} = %.0f TeV", ptVals.at(k) / 1000.);
+
+    addResoGraph(mg_recmu_eff_eta, &gr_recmu_eff_eta[k], leg_recmu_eff_eta, markerStyles.at(k), colors.at(k), s_pt);
+  }
+
+  TCanvas *c_recmu_eff_pt = new TCanvas("", "", 800, 600);
+
+  mg_recmu_eff_pt->Draw("APE");
+  DrawAxis(mg_recmu_eff_pt, leg_recmu_eff_pt, ptMin, ptMax, 0.0, 100, "p_{T} [GeV]", "reconstruction efficiency (%)", true, false);
+  leg_recmu_eff_pt->Draw();
+  pave->Draw();
+
+  c_recmu_eff_pt->Print(pdfOutput, "pdf");
+  c_recmu_eff_pt->Print(figPath + "img_recmu_eff_pt.pdf", "pdf");
+  c_recmu_eff_pt->Print(figPath + "img_recmu_eff_pt.png", "png");
+
+  TCanvas *c_recmu_eff_eta = new TCanvas("", "", 800, 600);
+
+  mg_recmu_eff_eta->Draw("APE");
+  DrawAxis(mg_recmu_eff_eta, leg_recmu_eff_eta, etaMin, etaMax, 0.0, 100, " #eta ", "reconstruction efficiency (%)", false, false);
+  leg_recmu_eff_eta->Draw();
+  pave->Draw();
+
+  c_recmu_eff_eta->Print(pdfOutput, "pdf");
+  c_recmu_eff_eta->Print(figPath + "img_recmu_eff_eta.pdf", "pdf");
+  c_recmu_eff_eta->Print(figPath + "img_recmu_eff_eta.png", "png");
+
+  /////////////////////////////////////////
+  // Photon Reconstruction Efficiency   ///
+  /////////////////////////////////////////
+
+  TMultiGraph *mg_recpho_eff_pt = new TMultiGraph("", "");
+  TMultiGraph *mg_recpho_eff_eta = new TMultiGraph("", "");
+
+  TLegend *leg_recpho_eff_pt = new TLegend(0.55, 0.22, 0.90, 0.48);
+  TLegend *leg_recpho_eff_eta = new TLegend(0.55, 0.22, 0.90, 0.48);
+
+  TGraphErrors *gr_recpho_eff_pt = new TGraphErrors[n_etabins];
+  TGraphErrors *gr_recpho_eff_eta = new TGraphErrors[n_ptbins];
+  TH1D *h_recpho_eff_pt, *h_recpho_eff_eta;
+
+  // loop over eta bins
+  for(k = 0; k < etaVals.size() - 1; k++)
+  {
+
+    h_recpho_eff_pt = GetEffPt<Photon>(branchPhoton, branchParticlePhoton, "Photon", 22, ptMin, ptMax, etaVals.at(k), etaVals.at(k + 1), treeReaderPhoton);
+    gr_recpho_eff_pt[k] = TGraphErrors(h_recpho_eff_pt);
+
+    s_etaMin = Form("%.1f", etaVals.at(k));
+    s_etaMax = Form("%.1f", etaVals.at(k + 1));
+
+    s_eta = "#gamma , " + s_etaMin + " < | #eta | < " + s_etaMax;
+
+    gr_recpho_eff_pt[k].SetName("recEff_" + s_etaMin + "_" + s_etaMax);
+
+    addResoGraph(mg_recpho_eff_pt, &gr_recpho_eff_pt[k], leg_recpho_eff_pt, markerStyles.at(k), colors.at(k), s_eta);
+  }
+
+  // loop over pt
+  for(k = 0; k < ptVals.size(); k++)
+  {
+    h_recpho_eff_eta = GetEffEta<Photon>(branchPhoton, branchParticlePhoton, "Photon", 22, 0.5 * ptVals.at(k), 2.0 * ptVals.at(k), etaMin, etaMax, treeReaderPhoton);
+    gr_recpho_eff_eta[k] = TGraphErrors(h_recpho_eff_eta);
+
+    s_pt = Form("#gamma , p_{T} = %.0f GeV", ptVals.at(k));
+    if(ptVals.at(k) >= 1000.) s_pt = Form("#gamma , p_{T} = %.0f TeV", ptVals.at(k) / 1000.);
+
+    addResoGraph(mg_recpho_eff_eta, &gr_recpho_eff_eta[k], leg_recpho_eff_eta, markerStyles.at(k), colors.at(k), s_pt);
+  }
+
+  TCanvas *c_recpho_eff_pt = new TCanvas("", "", 800, 600);
+
+  mg_recpho_eff_pt->Draw("APE");
+  DrawAxis(mg_recpho_eff_pt, leg_recpho_eff_pt, ptMin, ptMax, 0.0, 100, "p_{T} [GeV]", "reconstruction efficiency (%)", true, false);
+  leg_recpho_eff_pt->Draw();
+  pave->Draw();
+
+  c_recpho_eff_pt->Print(pdfOutput, "pdf");
+  c_recpho_eff_pt->Print(figPath + "img_recpho_eff_pt.pdf", "pdf");
+  c_recpho_eff_pt->Print(figPath + "img_recpho_eff_pt.png", "png");
+
+  TCanvas *c_recpho_eff_eta = new TCanvas("", "", 800, 600);
+
+  mg_recpho_eff_eta->Draw("APE");
+  DrawAxis(mg_recpho_eff_eta, leg_recpho_eff_eta, etaMin, etaMax, 0.0, 100, " #eta ", "reconstruction efficiency (%)", false, false);
+  leg_recpho_eff_eta->Draw();
+  pave->Draw();
+
+  c_recpho_eff_eta->Print(pdfOutput, "pdf");
+  c_recpho_eff_eta->Print(figPath + "img_recpho_eff_eta.pdf", "pdf");
+  c_recpho_eff_eta->Print(figPath + "img_recpho_eff_eta.png", "png");
+
+  /////////////////////////////////////////
+  // B-jets  Efficiency/ mistag rates   ///
+  /////////////////////////////////////////
+
+  TMultiGraph *mg_recbjet_eff_pt = new TMultiGraph("", "");
+  TMultiGraph *mg_recbjet_eff_eta = new TMultiGraph("", "");
+
+  TLegend *leg_recbjet_eff_pt = new TLegend(0.50, 0.22, 0.90, 0.48);
+  TLegend *leg_recbjet_eff_eta = new TLegend(0.50, 0.22, 0.90, 0.48);
+
+  TGraphErrors *gr_recbjet_eff_pt = new TGraphErrors[n_etabins];
+  TGraphErrors *gr_recbjet_eff_eta = new TGraphErrors[n_ptbins];
+  TH1D *h_recbjet_eff_pt, *h_recbjet_eff_eta;
+
+  // loop over eta bins
+  for(k = 0; k < etaVals.size() - 1; k++)
+  {
+
+    h_recbjet_eff_pt = GetJetEffPt<Jet>(branchPFBJet, "BJet", 5, ptMin, ptMax, etaVals.at(k), etaVals.at(k + 1), treeReaderBJet);
+    //h_recbjet_eff_pt = GetEffPt<Jet>(branchPFBJet, branchParticleBJet, "BJet", 5, ptMin, ptMax, etaVals.at(k), etaVals.at(k+1), treeReaderBJet);
+    gr_recbjet_eff_pt[k] = TGraphErrors(h_recbjet_eff_pt);
+
+    s_etaMin = Form("%.1f", etaVals.at(k));
+    s_etaMax = Form("%.1f", etaVals.at(k + 1));
+
+    s_eta = "b-jet , " + s_etaMin + " < | #eta | < " + s_etaMax;
+
+    gr_recbjet_eff_pt[k].SetName("recEff_" + s_etaMin + "_" + s_etaMax);
+
+    addResoGraph(mg_recbjet_eff_pt, &gr_recbjet_eff_pt[k], leg_recbjet_eff_pt, markerStyles.at(k), colors.at(k), s_eta);
+  }
+
+  // loop over pt
+  for(k = 0; k < ptVals.size(); k++)
+  {
+    h_recbjet_eff_eta = GetJetEffEta<Jet>(branchPFBJet, "BJet", 5, 0.5 * ptVals.at(k), 2.0 * ptVals.at(k), etaMin, etaMax, treeReaderBJet);
+    //h_recbjet_eff_eta = GetEffEta<Jet>(branchPFBJet, branchParticleBJet, "BJet", 5, 0.5*ptVals.at(k), 2.0*ptVals.at(k) ,etaMin, etaMax , treeReaderBJet);
+    gr_recbjet_eff_eta[k] = TGraphErrors(h_recbjet_eff_eta);
+
+    s_pt = Form("b-jet , p_{T} = %.0f GeV", ptVals.at(k));
+    if(ptVals.at(k) >= 1000.) s_pt = Form("b-jet , p_{T} = %.0f TeV", ptVals.at(k) / 1000.);
+
+    addResoGraph(mg_recbjet_eff_eta, &gr_recbjet_eff_eta[k], leg_recbjet_eff_eta, markerStyles.at(k), colors.at(k), s_pt);
+  }
+
+  TCanvas *c_recbjet_eff_pt = new TCanvas("", "", 800, 600);
+
+  mg_recbjet_eff_pt->Draw("APE");
+  DrawAxis(mg_recbjet_eff_pt, leg_recbjet_eff_pt, ptMin, ptMax, 0.0, 100, "p_{T} [GeV]", "b - tag efficiency (%)", true, false);
+  leg_recbjet_eff_pt->Draw();
+  pave->Draw();
+
+  c_recbjet_eff_pt->Print(pdfOutput, "pdf");
+  c_recbjet_eff_pt->Print(figPath + "img_recbjet_eff_pt.pdf", "pdf");
+  c_recbjet_eff_pt->Print(figPath + "img_recbjet_eff_pt.png", "png");
+
+  TCanvas *c_recbjet_eff_eta = new TCanvas("", "", 800, 600);
+
+  mg_recbjet_eff_eta->Draw("APE");
+  DrawAxis(mg_recbjet_eff_eta, leg_recbjet_eff_eta, etaMin, etaMax, 0.0, 100, " #eta ", "b - tag efficiency (%)", false, false);
+  leg_recbjet_eff_eta->Draw();
+  pave->Draw();
+
+  c_recbjet_eff_eta->Print(pdfOutput, "pdf");
+  c_recbjet_eff_eta->Print(figPath + "img_recbjet_eff_eta.pdf", "pdf");
+  c_recbjet_eff_eta->Print(figPath + "img_recbjet_eff_eta.png", "png");
+
+  // ------ c - mistag  ------
+
+  TMultiGraph *mg_recbjet_cmis_pt = new TMultiGraph("", "");
+  TMultiGraph *mg_recbjet_cmis_eta = new TMultiGraph("", "");
+
+  TLegend *leg_recbjet_cmis_pt = new TLegend(0.50, 0.64, 0.90, 0.90);
+  TLegend *leg_recbjet_cmis_eta = new TLegend(0.50, 0.64, 0.90, 0.90);
+
+  TGraphErrors *gr_recbjet_cmis_pt = new TGraphErrors[n_etabins];
+  TGraphErrors *gr_recbjet_cmis_eta = new TGraphErrors[n_ptbins];
+  TH1D *h_recbjet_cmis_pt, *h_recbjet_cmis_eta;
+
+  // loop over eta bins
+  for(k = 0; k < etaVals.size() - 1; k++)
+  {
+
+    h_recbjet_cmis_pt = GetJetEffPt<Jet>(branchPFCJet, "CJet", 4, ptMin, ptMax, etaVals.at(k), etaVals.at(k + 1), treeReaderCJet);
+    //h_recbjet_cmis_pt = GetEffPt<Jet>(branchPFCJet, branchParticleCJet, "CJet", 4, ptMin, ptMax, etaVals.at(k), etaVals.at(k+1), treeReaderCJet);
+    gr_recbjet_cmis_pt[k] = TGraphErrors(h_recbjet_cmis_pt);
+
+    s_etaMin = Form("%.1f", etaVals.at(k));
+    s_etaMax = Form("%.1f", etaVals.at(k + 1));
+
+    s_eta = "c-jet , " + s_etaMin + " < | #eta | < " + s_etaMax;
+
+    gr_recbjet_cmis_pt[k].SetName("recEff_" + s_etaMin + "_" + s_etaMax);
+
+    addResoGraph(mg_recbjet_cmis_pt, &gr_recbjet_cmis_pt[k], leg_recbjet_cmis_pt, markerStyles.at(k), colors.at(k), s_eta);
+  }
+
+  // loop over pt
+  for(k = 0; k < ptVals.size(); k++)
+  {
+    h_recbjet_cmis_eta = GetJetEffEta<Jet>(branchPFCJet, "CJet", 4, 0.5 * ptVals.at(k), 2.0 * ptVals.at(k), etaMin, etaMax, treeReaderCJet);
+    //h_recbjet_cmis_eta = GetEffEta<Jet>(branchPFCJet, branchParticleCJet, "CJet", 4, 0.5*ptVals.at(k), 2.0*ptVals.at(k) ,etaMin, etaMax , treeReaderCJet);
+    gr_recbjet_cmis_eta[k] = TGraphErrors(h_recbjet_cmis_eta);
+
+    s_pt = Form("c-jet , p_{T} = %.0f GeV", ptVals.at(k));
+    if(ptVals.at(k) >= 1000.) s_pt = Form("c-jet , p_{T} = %.0f TeV", ptVals.at(k) / 1000.);
+
+    addResoGraph(mg_recbjet_cmis_eta, &gr_recbjet_cmis_eta[k], leg_recbjet_cmis_eta, markerStyles.at(k), colors.at(k), s_pt);
+  }
+
+  TCanvas *c_recbjet_cmis_pt = new TCanvas("", "", 800, 600);
+
+  mg_recbjet_cmis_pt->Draw("APE");
+  DrawAxis(mg_recbjet_cmis_pt, leg_recbjet_cmis_pt, ptMin, ptMax, 0.0, 20, "p_{T} [GeV]", "c - mistag rate (%)", true, false);
+  leg_recbjet_cmis_pt->Draw();
+  pave->Draw();
+
+  c_recbjet_cmis_pt->Print(pdfOutput, "pdf");
+  c_recbjet_cmis_pt->Print(figPath + "img_recbjet_cmis_pt.pdf", "pdf");
+  c_recbjet_cmis_pt->Print(figPath + "img_recbjet_cmis_pt.png", "png");
+
+  TCanvas *c_recbjet_cmis_eta = new TCanvas("", "", 800, 600);
+
+  mg_recbjet_cmis_eta->Draw("APE");
+  DrawAxis(mg_recbjet_cmis_eta, leg_recbjet_cmis_eta, etaMin, etaMax, 0.0, 20, " #eta ", "c - mistag rate (%)", false, false);
+  leg_recbjet_cmis_eta->Draw();
+  pave->Draw();
+
+  c_recbjet_cmis_eta->Print(pdfOutput, "pdf");
+  c_recbjet_cmis_eta->Print(figPath + "img_recbjet_cmis_eta.pdf", "pdf");
+  c_recbjet_cmis_eta->Print(figPath + "img_recbjet_cmis_eta.png", "png");
+
+  // ------ light - mistag  ------
+
+  TMultiGraph *mg_recbjet_lmis_pt = new TMultiGraph("", "");
+  TMultiGraph *mg_recbjet_lmis_eta = new TMultiGraph("", "");
+
+  TLegend *leg_recbjet_lmis_pt = new TLegend(0.50, 0.64, 0.90, 0.90);
+  TLegend *leg_recbjet_lmis_eta = new TLegend(0.50, 0.64, 0.90, 0.90);
+
+  TGraphErrors *gr_recbjet_lmis_pt = new TGraphErrors[n_etabins];
+  TGraphErrors *gr_recbjet_lmis_eta = new TGraphErrors[n_ptbins];
+  TH1D *h_recbjet_lmis_pt, *h_recbjet_lmis_eta;
+
+  // loop over eta bins
+  for(k = 0; k < etaVals.size() - 1; k++)
+  {
+
+    h_recbjet_lmis_pt = GetJetEffPt<Jet>(branchJet, "Jet", 1, ptMin, ptMax, etaVals.at(k), etaVals.at(k + 1), treeReaderJet);
+    //h_recbjet_lmis_pt = GetEffPt<Jet>(branchJet, branchParticleJet, "Jet", 1, ptMin, ptMax, etaVals.at(k), etaVals.at(k+1), treeReaderJet);
+    gr_recbjet_lmis_pt[k] = TGraphErrors(h_recbjet_lmis_pt);
+
+    s_etaMin = Form("%.1f", etaVals.at(k));
+    s_etaMax = Form("%.1f", etaVals.at(k + 1));
+
+    s_eta = "uds-jet , " + s_etaMin + " < | #eta | < " + s_etaMax;
+
+    gr_recbjet_lmis_pt[k].SetName("recEff_" + s_etaMin + "_" + s_etaMax);
+
+    addResoGraph(mg_recbjet_lmis_pt, &gr_recbjet_lmis_pt[k], leg_recbjet_lmis_pt, markerStyles.at(k), colors.at(k), s_eta);
+  }
+
+  // loop over pt
+  for(k = 0; k < ptVals.size(); k++)
+  {
+    h_recbjet_lmis_eta = GetJetEffEta<Jet>(branchJet, "Jet", 1, 0.5 * ptVals.at(k), 2.0 * ptVals.at(k), etaMin, etaMax, treeReaderJet);
+    //h_recbjet_lmis_eta = GetEffEta<Jet>(branchJet, branchParticleJet, "Jet", 1, 0.5*ptVals.at(k), 2.0*ptVals.at(k) ,etaMin, etaMax , treeReaderJet);
+    gr_recbjet_lmis_eta[k] = TGraphErrors(h_recbjet_lmis_eta);
+
+    s_pt = Form("uds-jet , p_{T} = %.0f GeV", ptVals.at(k));
+    if(ptVals.at(k) >= 1000.) s_pt = Form("uds-jet , p_{T} = %.0f TeV", ptVals.at(k) / 1000.);
+
+    addResoGraph(mg_recbjet_lmis_eta, &gr_recbjet_lmis_eta[k], leg_recbjet_lmis_eta, markerStyles.at(k), colors.at(k), s_pt);
+  }
+
+  TCanvas *c_recbjet_lmis_pt = new TCanvas("", "", 800, 600);
+
+  mg_recbjet_lmis_pt->Draw("APE");
+
+  DrawAxis(mg_recbjet_lmis_pt, leg_recbjet_lmis_pt, ptMin, ptMax, 0.0, 1.0, "p_{T} [GeV]", "light - mistag rate (%)", true, false);
+
+  leg_recbjet_lmis_pt->Draw();
+  pave->Draw();
+
+  c_recbjet_lmis_pt->Print(pdfOutput, "pdf");
+  c_recbjet_lmis_pt->Print(figPath + "img_recbjet_lmis_pt.pdf", "pdf");
+  c_recbjet_lmis_pt->Print(figPath + "img_recbjet_lmis_pt.png", "png");
+
+  TCanvas *c_recbjet_lmis_eta = new TCanvas("", "", 800, 600);
+
+  mg_recbjet_lmis_eta->Draw("APE");
+  DrawAxis(mg_recbjet_lmis_eta, leg_recbjet_lmis_eta, etaMin, etaMax, 0.0, 1.0, " #eta ", "light - mistag rate (%)", false, false);
+  leg_recbjet_lmis_eta->Draw();
+  pave->Draw();
+
+  c_recbjet_lmis_eta->Print(pdfOutput, "pdf");
+  c_recbjet_lmis_eta->Print(figPath + "img_recbjet_lmis_eta.pdf", "pdf");
+  c_recbjet_lmis_eta->Print(figPath + "img_recbjet_lmis_eta.png", "png");
+
+  ///////////////////////////////////////////
+  // tau-jets  Efficiency/ mistag rates   ///
+  ///////////////////////////////////////////
+
+  TMultiGraph *mg_rectaujet_eff_pt = new TMultiGraph("", "");
+  TMultiGraph *mg_rectaujet_eff_eta = new TMultiGraph("", "");
+
+  TLegend *leg_rectaujet_eff_pt = new TLegend(0.50, 0.22, 0.90, 0.48);
+  TLegend *leg_rectaujet_eff_eta = new TLegend(0.50, 0.22, 0.90, 0.48);
+
+  TGraphErrors *gr_rectaujet_eff_pt = new TGraphErrors[n_etabins];
+  TGraphErrors *gr_rectaujet_eff_eta = new TGraphErrors[n_ptbins];
+  TH1D *h_rectaujet_eff_pt, *h_rectaujet_eff_eta;
+
+  // loop over eta bins
+  for(k = 0; k < etaVals.size() - 1; k++)
+  {
+
+    h_rectaujet_eff_pt = GetTauEffPt<Jet>(branchPFTauJet, branchParticleTauJet, "TauJet", 15, ptMin, ptMax, etaVals.at(k), etaVals.at(k + 1), treeReaderTauJet);
+    gr_rectaujet_eff_pt[k] = TGraphErrors(h_rectaujet_eff_pt);
+
+    s_etaMin = Form("%.1f", etaVals.at(k));
+    s_etaMax = Form("%.1f", etaVals.at(k + 1));
+
+    s_eta = "#tau-jet , " + s_etaMin + " < | #eta | < " + s_etaMax;
+
+    gr_rectaujet_eff_pt[k].SetName("recEff_" + s_etaMin + "_" + s_etaMax);
+
+    addResoGraph(mg_rectaujet_eff_pt, &gr_rectaujet_eff_pt[k], leg_rectaujet_eff_pt, markerStyles.at(k), colors.at(k), s_eta);
+  }
+
+  // loop over pt
+  for(k = 0; k < ptVals.size(); k++)
+  {
+    h_rectaujet_eff_eta = GetTauEffEta<Jet>(branchPFTauJet, branchParticleTauJet, "TauJet", 15, 0.5 * ptVals.at(k), 2.0 * ptVals.at(k), etaMin, etaMax, treeReaderTauJet);
+    gr_rectaujet_eff_eta[k] = TGraphErrors(h_rectaujet_eff_eta);
+
+    s_pt = Form("#tau-jet , p_{T} = %.0f GeV", ptVals.at(k));
+    if(ptVals.at(k) >= 1000.) s_pt = Form("#tau-jet , p_{T} = %.0f TeV", ptVals.at(k) / 1000.);
+
+    addResoGraph(mg_rectaujet_eff_eta, &gr_rectaujet_eff_eta[k], leg_rectaujet_eff_eta, markerStyles.at(k), colors.at(k), s_pt);
+  }
+
+  TCanvas *c_rectaujet_eff_pt = new TCanvas("", "", 800, 600);
+
+  mg_rectaujet_eff_pt->Draw("APE");
+  DrawAxis(mg_rectaujet_eff_pt, leg_rectaujet_eff_pt, ptMin, ptMax, 0.0, 100, "p_{T} [GeV]", "#tau - tag efficiency (%)", true, false);
+  leg_rectaujet_eff_pt->Draw();
+  pave->Draw();
+
+  c_rectaujet_eff_pt->Print(pdfOutput, "pdf");
+  c_rectaujet_eff_pt->Print(figPath + "img_rectaujet_eff_pt.pdf", "pdf");
+  c_rectaujet_eff_pt->Print(figPath + "img_rectaujet_eff_pt.png", "png");
+
+  TCanvas *c_rectaujet_eff_eta = new TCanvas("", "", 800, 600);
+
+  mg_rectaujet_eff_eta->Draw("APE");
+  DrawAxis(mg_rectaujet_eff_eta, leg_rectaujet_eff_eta, etaMin, etaMax, 0.0, 100., " #eta ", "#tau - tag efficiency (%)", false, false);
+  leg_rectaujet_eff_eta->Draw();
+  pave->Draw();
+
+  c_rectaujet_eff_eta->Print(pdfOutput, "pdf");
+  c_rectaujet_eff_eta->Print(figPath + "img_rectaujet_eff_eta.pdf", "pdf");
+  c_rectaujet_eff_eta->Print(figPath + "img_rectaujet_eff_eta.png", "png");
+
+  //--------------- tau mistag rate ----------
+
+  TMultiGraph *mg_rectaujet_mis_pt = new TMultiGraph("", "");
+  TMultiGraph *mg_rectaujet_mis_eta = new TMultiGraph("", "");
+
+  TLegend *leg_rectaujet_mis_pt = new TLegend(0.50, 0.64, 0.90, 0.90);
+  TLegend *leg_rectaujet_mis_eta = new TLegend(0.50, 0.64, 0.90, 0.90);
+
+  TGraphErrors *gr_rectaujet_mis_pt = new TGraphErrors[n_etabins];
+  TGraphErrors *gr_rectaujet_mis_eta = new TGraphErrors[n_ptbins];
+  TH1D *h_rectaujet_mis_pt, *h_rectaujet_mis_eta;
+
+  // loop over eta bins
+  for(k = 0; k < etaVals.size() - 1; k++)
+  {
+
+    h_rectaujet_mis_pt = GetTauEffPt<Jet>(branchJet, branchParticleJet, "TauJet", 1, ptMin, ptMax, etaVals.at(k), etaVals.at(k + 1), treeReaderJet);
+    gr_rectaujet_mis_pt[k] = TGraphErrors(h_rectaujet_mis_pt);
+
+    s_etaMin = Form("%.1f", etaVals.at(k));
+    s_etaMax = Form("%.1f", etaVals.at(k + 1));
+
+    s_eta = "uds-jet , " + s_etaMin + " < | #eta | < " + s_etaMax;
+
+    gr_rectaujet_mis_pt[k].SetName("recEff_" + s_etaMin + "_" + s_etaMax);
+
+    addResoGraph(mg_rectaujet_mis_pt, &gr_rectaujet_mis_pt[k], leg_rectaujet_mis_pt, markerStyles.at(k), colors.at(k), s_eta);
+  }
+
+  // loop over pt
+  for(k = 0; k < ptVals.size(); k++)
+  {
+    h_rectaujet_mis_eta = GetTauEffEta<Jet>(branchJet, branchParticleJet, "TauJet", 1, 0.5 * ptVals.at(k), 2.0 * ptVals.at(k), etaMin, etaMax, treeReaderJet);
+    gr_rectaujet_mis_eta[k] = TGraphErrors(h_rectaujet_mis_eta);
+
+    s_pt = Form("uds-jet , p_{T} = %.0f GeV", ptVals.at(k));
+    if(ptVals.at(k) >= 1000.) s_pt = Form("uds-jet , p_{T} = %.0f TeV", ptVals.at(k) / 1000.);
+
+    addResoGraph(mg_rectaujet_mis_eta, &gr_rectaujet_mis_eta[k], leg_rectaujet_mis_eta, markerStyles.at(k), colors.at(k), s_pt);
+  }
+
+  TCanvas *c_rectaujet_mis_pt = new TCanvas("", "", 800, 600);
+
+  mg_rectaujet_mis_pt->Draw("APE");
+  DrawAxis(mg_rectaujet_mis_pt, leg_rectaujet_mis_pt, ptMin, ptMax, 0.0, 5., "p_{T} [GeV]", "#tau - mistag(%)", true, false);
+  leg_rectaujet_mis_pt->Draw();
+  pave->Draw();
+
+  c_rectaujet_mis_pt->Print(pdfOutput, "pdf");
+  c_rectaujet_mis_pt->Print(figPath + "img_rectaujet_mis_pt.pdf", "pdf");
+  c_rectaujet_mis_pt->Print(figPath + "img_rectaujet_mis_pt.png", "png");
+
+  TCanvas *c_rectaujet_mis_eta = new TCanvas("", "", 800, 600);
+
+  mg_rectaujet_mis_eta->Draw("APE");
+  DrawAxis(mg_rectaujet_mis_eta, leg_rectaujet_mis_eta, etaMin, etaMax, 0.0, 5., " #eta ", "#tau - mistag (%)", false, false);
+  leg_rectaujet_mis_eta->Draw();
+  pave->Draw();
+
+  c_rectaujet_mis_eta->Print(pdfOutput + ")", "pdf");
+  c_rectaujet_mis_eta->Print(figPath + "img_rectaujet_mis_eta.pdf", "pdf");
+  c_rectaujet_mis_eta->Print(figPath + "img_rectaujet_mis_eta.png", "png");
+
+  //   ----   store resolution histograms in the output (for leave efficiencies out) ---
+
+  TFile *fout = new TFile(outputFile, "recreate");
+
+  for(int bin = 0; bin < Nbins; bin++)
+  {
+
+    for(k = 0; k < etaVals.size() - 1; k++)
     {
-
-       h_recele_eff_pt = GetEffPt<Electron>(branchElectron, branchParticleElectron, "Electron", 11, ptMin, ptMax, etaVals.at(k), etaVals.at(k+1), treeReaderElectron);
-       gr_recele_eff_pt[k] = TGraphErrors(h_recele_eff_pt);
-
-       s_etaMin = Form("%.1f",etaVals.at(k));
-       s_etaMax = Form("%.1f",etaVals.at(k+1));
-
-       s_eta = "e^{ #pm} , " + s_etaMin + " < | #eta | < "+s_etaMax;
-
-       gr_recele_eff_pt[k].SetName("recEff_"+s_etaMin+"_"+s_etaMax);
-
-       addResoGraph(mg_recele_eff_pt, &gr_recele_eff_pt[k], leg_recele_eff_pt, markerStyles.at(k), colors.at(k), s_eta);
+      plots_trkpi_res_pt[k].at(bin).resolHist->Write();
+      plots_trkele_res_pt[k].at(bin).resolHist->Write();
+      plots_trkmu_res_pt[k].at(bin).resolHist->Write();
+      plots_ecal_res_e[k].at(bin).resolHist->Write();
+      plots_hcal_res_e[k].at(bin).resolHist->Write();
+      plots_pfele_res_e[k].at(bin).resolHist->Write();
+      plots_pfpi_res_e[k].at(bin).resolHist->Write();
+      plots_pfjet_res_e[k].at(bin).resolHist->Write();
+      plots_cajet_res_e[k].at(bin).resolHist->Write();
     }
 
-    // loop over pt
-    for (k = 0; k < ptVals.size(); k++)
+    for(k = 0; k < ptVals.size(); k++)
     {
-       h_recele_eff_eta = GetEffEta<Electron>(branchElectron, branchParticleElectron, "Electron", 11, 0.5*ptVals.at(k), 2.0*ptVals.at(k) ,etaMin, etaMax , treeReaderElectron);
-       gr_recele_eff_eta[k] = TGraphErrors(h_recele_eff_eta);
-
-       s_pt = Form("e^{ #pm} , p_{T} = %.0f GeV",ptVals.at(k));
-       if(ptVals.at(k) >= 1000.) s_pt = Form("e^{ #pm} , p_{T} = %.0f TeV",ptVals.at(k)/1000.);
-
-       addResoGraph(mg_recele_eff_eta, &gr_recele_eff_eta[k], leg_recele_eff_eta, markerStyles.at(k), colors.at(k), s_pt );
-    }
-
-    TCanvas *c_recele_eff_pt = new TCanvas("","", 800, 600);
-
-    mg_recele_eff_pt->Draw("APE");
-    DrawAxis(mg_recele_eff_pt, leg_recele_eff_pt, ptMin, ptMax, 0.0, 100, "p_{T} [GeV]", "reconstruction efficiency (%)", true, false);
-    leg_recele_eff_pt->Draw();
-    pave->Draw();
-
-    c_recele_eff_pt->Print(pdfOutput,"pdf");
-    c_recele_eff_pt->Print(figPath+"img_recele_eff_pt.pdf","pdf");
-    c_recele_eff_pt->Print(figPath+"img_recele_eff_pt.png","png");
-
-    TCanvas *c_recele_eff_eta = new TCanvas("","", 800, 600);
-
-    mg_recele_eff_eta->Draw("APE");
-    DrawAxis(mg_recele_eff_eta, leg_recele_eff_eta, etaMin, etaMax, 0.0, 100, " #eta ", "reconstruction efficiency (%)", false, false);
-    leg_recele_eff_eta->Draw();
-    pave->Draw();
-
-    c_recele_eff_eta->Print(pdfOutput,"pdf");
-    c_recele_eff_eta->Print(figPath+"img_recele_eff_eta.pdf","pdf");
-    c_recele_eff_eta->Print(figPath+"img_recele_eff_eta.png","png");
-
-
-    /////////////////////////////////////////
-    // Muon Reconstruction Efficiency ///
-    /////////////////////////////////////////
-
-    TMultiGraph *mg_recmu_eff_pt  = new TMultiGraph("","");
-    TMultiGraph *mg_recmu_eff_eta = new TMultiGraph("","");
-
-    TLegend *leg_recmu_eff_pt  = new TLegend(0.55,0.22,0.90,0.48);
-    TLegend *leg_recmu_eff_eta = new TLegend(0.55,0.22,0.90,0.48);
-
-    TGraphErrors *gr_recmu_eff_pt  = new TGraphErrors[n_etabins];
-    TGraphErrors *gr_recmu_eff_eta = new TGraphErrors[n_ptbins];
-    TH1D* h_recmu_eff_pt, *h_recmu_eff_eta;
-
-    // loop over eta bins
-    for (k = 0; k < etaVals.size()-1; k++)
-    {
-
-       h_recmu_eff_pt = GetEffPt<Muon>(branchMuon, branchParticleMuon, "muon", 13, ptMin, ptMax, etaVals.at(k), etaVals.at(k+1), treeReaderMuon);
-       gr_recmu_eff_pt[k] = TGraphErrors(h_recmu_eff_pt);
-
-       s_etaMin = Form("%.1f",etaVals.at(k));
-       s_etaMax = Form("%.1f",etaVals.at(k+1));
-
-       s_eta = "#mu^{ #pm} , " + s_etaMin + " < | #eta | < "+s_etaMax;
-
-       gr_recmu_eff_pt[k].SetName("recEff_"+s_etaMin+"_"+s_etaMax);
-
-       addResoGraph(mg_recmu_eff_pt, &gr_recmu_eff_pt[k], leg_recmu_eff_pt, markerStyles.at(k), colors.at(k), s_eta);
-    }
-
-    // loop over pt
-    for (k = 0; k < ptVals.size(); k++)
-    {
-       h_recmu_eff_eta = GetEffEta<Muon>(branchMuon, branchParticleMuon, "muon", 13, 0.5*ptVals.at(k), 2.0*ptVals.at(k) ,etaMin, etaMax , treeReaderMuon);
-       gr_recmu_eff_eta[k] = TGraphErrors(h_recmu_eff_eta);
-
-       s_pt = Form("#mu^{ #pm} , p_{T} = %.0f GeV",ptVals.at(k));
-       if(ptVals.at(k) >= 1000.) s_pt = Form("#mu^{ #pm} , p_{T} = %.0f TeV",ptVals.at(k)/1000.);
-
-       addResoGraph(mg_recmu_eff_eta, &gr_recmu_eff_eta[k], leg_recmu_eff_eta, markerStyles.at(k), colors.at(k), s_pt );
-    }
-
-    TCanvas *c_recmu_eff_pt = new TCanvas("","", 800, 600);
-
-    mg_recmu_eff_pt->Draw("APE");
-    DrawAxis(mg_recmu_eff_pt, leg_recmu_eff_pt, ptMin, ptMax, 0.0, 100, "p_{T} [GeV]", "reconstruction efficiency (%)", true, false);
-    leg_recmu_eff_pt->Draw();
-    pave->Draw();
-
-    c_recmu_eff_pt->Print(pdfOutput,"pdf");
-    c_recmu_eff_pt->Print(figPath+"img_recmu_eff_pt.pdf","pdf");
-    c_recmu_eff_pt->Print(figPath+"img_recmu_eff_pt.png","png");
-
-    TCanvas *c_recmu_eff_eta = new TCanvas("","", 800, 600);
-
-    mg_recmu_eff_eta->Draw("APE");
-    DrawAxis(mg_recmu_eff_eta, leg_recmu_eff_eta, etaMin, etaMax, 0.0, 100, " #eta ", "reconstruction efficiency (%)", false, false);
-    leg_recmu_eff_eta->Draw();
-    pave->Draw();
-
-    c_recmu_eff_eta->Print(pdfOutput,"pdf");
-    c_recmu_eff_eta->Print(figPath+"img_recmu_eff_eta.pdf","pdf");
-    c_recmu_eff_eta->Print(figPath+"img_recmu_eff_eta.png","png");
-
-
-    /////////////////////////////////////////
-    // Photon Reconstruction Efficiency   ///
-    /////////////////////////////////////////
-
-    TMultiGraph *mg_recpho_eff_pt  = new TMultiGraph("","");
-    TMultiGraph *mg_recpho_eff_eta = new TMultiGraph("","");
-
-    TLegend *leg_recpho_eff_pt  = new TLegend(0.55,0.22,0.90,0.48);
-    TLegend *leg_recpho_eff_eta = new TLegend(0.55,0.22,0.90,0.48);
-
-    TGraphErrors *gr_recpho_eff_pt  = new TGraphErrors[n_etabins];
-    TGraphErrors *gr_recpho_eff_eta = new TGraphErrors[n_ptbins];
-    TH1D* h_recpho_eff_pt, *h_recpho_eff_eta;
-
-    // loop over eta bins
-    for (k = 0; k < etaVals.size()-1; k++)
-    {
-
-       h_recpho_eff_pt = GetEffPt<Photon>(branchPhoton, branchParticlePhoton, "Photon", 22, ptMin, ptMax, etaVals.at(k), etaVals.at(k+1), treeReaderPhoton);
-       gr_recpho_eff_pt[k] = TGraphErrors(h_recpho_eff_pt);
-
-       s_etaMin = Form("%.1f",etaVals.at(k));
-       s_etaMax = Form("%.1f",etaVals.at(k+1));
-
-       s_eta = "#gamma , " + s_etaMin + " < | #eta | < "+s_etaMax;
-
-       gr_recpho_eff_pt[k].SetName("recEff_"+s_etaMin+"_"+s_etaMax);
-
-       addResoGraph(mg_recpho_eff_pt, &gr_recpho_eff_pt[k], leg_recpho_eff_pt, markerStyles.at(k), colors.at(k), s_eta);
-    }
-
-    // loop over pt
-    for (k = 0; k < ptVals.size(); k++)
-    {
-       h_recpho_eff_eta = GetEffEta<Photon>(branchPhoton, branchParticlePhoton, "Photon", 22, 0.5*ptVals.at(k), 2.0*ptVals.at(k) ,etaMin, etaMax , treeReaderPhoton);
-       gr_recpho_eff_eta[k] = TGraphErrors(h_recpho_eff_eta);
-
-       s_pt = Form("#gamma , p_{T} = %.0f GeV",ptVals.at(k));
-       if(ptVals.at(k) >= 1000.) s_pt = Form("#gamma , p_{T} = %.0f TeV",ptVals.at(k)/1000.);
-
-       addResoGraph(mg_recpho_eff_eta, &gr_recpho_eff_eta[k], leg_recpho_eff_eta, markerStyles.at(k), colors.at(k), s_pt );
-    }
-
-    TCanvas *c_recpho_eff_pt = new TCanvas("","", 800, 600);
-
-    mg_recpho_eff_pt->Draw("APE");
-    DrawAxis(mg_recpho_eff_pt, leg_recpho_eff_pt, ptMin, ptMax, 0.0, 100, "p_{T} [GeV]", "reconstruction efficiency (%)", true, false);
-    leg_recpho_eff_pt->Draw();
-    pave->Draw();
-
-    c_recpho_eff_pt->Print(pdfOutput,"pdf");
-    c_recpho_eff_pt->Print(figPath+"img_recpho_eff_pt.pdf","pdf");
-    c_recpho_eff_pt->Print(figPath+"img_recpho_eff_pt.png","png");
-
-    TCanvas *c_recpho_eff_eta = new TCanvas("","", 800, 600);
-
-    mg_recpho_eff_eta->Draw("APE");
-    DrawAxis(mg_recpho_eff_eta, leg_recpho_eff_eta, etaMin, etaMax, 0.0, 100, " #eta ", "reconstruction efficiency (%)", false, false);
-    leg_recpho_eff_eta->Draw();
-    pave->Draw();
-
-    c_recpho_eff_eta->Print(pdfOutput,"pdf");
-    c_recpho_eff_eta->Print(figPath+"img_recpho_eff_eta.pdf","pdf");
-    c_recpho_eff_eta->Print(figPath+"img_recpho_eff_eta.png","png");
-    
-    /////////////////////////////////////////
-    // B-jets  Efficiency/ mistag rates   ///
-    /////////////////////////////////////////
-
-    TMultiGraph *mg_recbjet_eff_pt  = new TMultiGraph("","");
-    TMultiGraph *mg_recbjet_eff_eta = new TMultiGraph("","");
-
-    TLegend *leg_recbjet_eff_pt  = new TLegend(0.50,0.22,0.90,0.48);
-    TLegend *leg_recbjet_eff_eta = new TLegend(0.50,0.22,0.90,0.48);
-
-    TGraphErrors *gr_recbjet_eff_pt  = new TGraphErrors[n_etabins];
-    TGraphErrors *gr_recbjet_eff_eta = new TGraphErrors[n_ptbins];
-    TH1D* h_recbjet_eff_pt, *h_recbjet_eff_eta;
-
-    // loop over eta bins
-    for (k = 0; k < etaVals.size()-1; k++)
-    {
-
-       h_recbjet_eff_pt = GetJetEffPt<Jet>(branchPFBJet, "BJet", 5, ptMin, ptMax, etaVals.at(k), etaVals.at(k+1), treeReaderBJet);
-       //h_recbjet_eff_pt = GetEffPt<Jet>(branchPFBJet, branchParticleBJet, "BJet", 5, ptMin, ptMax, etaVals.at(k), etaVals.at(k+1), treeReaderBJet);
-       gr_recbjet_eff_pt[k] = TGraphErrors(h_recbjet_eff_pt);
-
-       s_etaMin = Form("%.1f",etaVals.at(k));
-       s_etaMax = Form("%.1f",etaVals.at(k+1));
-
-       s_eta = "b-jet , " + s_etaMin + " < | #eta | < "+s_etaMax;
-
-       gr_recbjet_eff_pt[k].SetName("recEff_"+s_etaMin+"_"+s_etaMax);
-
-       addResoGraph(mg_recbjet_eff_pt, &gr_recbjet_eff_pt[k], leg_recbjet_eff_pt, markerStyles.at(k), colors.at(k), s_eta);
-    }
-
-    // loop over pt
-    for (k = 0; k < ptVals.size(); k++)
-    {
-       h_recbjet_eff_eta = GetJetEffEta<Jet>(branchPFBJet, "BJet", 5, 0.5*ptVals.at(k), 2.0*ptVals.at(k) ,etaMin, etaMax , treeReaderBJet);
-       //h_recbjet_eff_eta = GetEffEta<Jet>(branchPFBJet, branchParticleBJet, "BJet", 5, 0.5*ptVals.at(k), 2.0*ptVals.at(k) ,etaMin, etaMax , treeReaderBJet);
-       gr_recbjet_eff_eta[k] = TGraphErrors(h_recbjet_eff_eta);
-
-       s_pt = Form("b-jet , p_{T} = %.0f GeV",ptVals.at(k));
-       if(ptVals.at(k) >= 1000.) s_pt = Form("b-jet , p_{T} = %.0f TeV",ptVals.at(k)/1000.);
-
-       addResoGraph(mg_recbjet_eff_eta, &gr_recbjet_eff_eta[k], leg_recbjet_eff_eta, markerStyles.at(k), colors.at(k), s_pt );
-    }
-
-    TCanvas *c_recbjet_eff_pt = new TCanvas("","", 800, 600);
-
-    mg_recbjet_eff_pt->Draw("APE");
-    DrawAxis(mg_recbjet_eff_pt, leg_recbjet_eff_pt, ptMin, ptMax, 0.0, 100, "p_{T} [GeV]", "b - tag efficiency (%)", true, false);
-    leg_recbjet_eff_pt->Draw();
-    pave->Draw();
-
-    c_recbjet_eff_pt->Print(pdfOutput,"pdf");
-    c_recbjet_eff_pt->Print(figPath+"img_recbjet_eff_pt.pdf","pdf");
-    c_recbjet_eff_pt->Print(figPath+"img_recbjet_eff_pt.png","png");
-
-    TCanvas *c_recbjet_eff_eta = new TCanvas("","", 800, 600);
-
-    mg_recbjet_eff_eta->Draw("APE");
-    DrawAxis(mg_recbjet_eff_eta, leg_recbjet_eff_eta, etaMin, etaMax, 0.0, 100, " #eta ", "b - tag efficiency (%)", false, false);
-    leg_recbjet_eff_eta->Draw();
-    pave->Draw();
-
-    c_recbjet_eff_eta->Print(pdfOutput,"pdf");
-    c_recbjet_eff_eta->Print(figPath+"img_recbjet_eff_eta.pdf","pdf");
-    c_recbjet_eff_eta->Print(figPath+"img_recbjet_eff_eta.png","png");
-
-    // ------ c - mistag  ------
-
-    TMultiGraph *mg_recbjet_cmis_pt  = new TMultiGraph("","");
-    TMultiGraph *mg_recbjet_cmis_eta = new TMultiGraph("","");
-
-    TLegend *leg_recbjet_cmis_pt  = new TLegend(0.50,0.64,0.90,0.90);
-    TLegend *leg_recbjet_cmis_eta = new TLegend(0.50,0.64,0.90,0.90);
-
-    TGraphErrors *gr_recbjet_cmis_pt  = new TGraphErrors[n_etabins];
-    TGraphErrors *gr_recbjet_cmis_eta = new TGraphErrors[n_ptbins];
-    TH1D* h_recbjet_cmis_pt, *h_recbjet_cmis_eta;
-
-    // loop over eta bins
-    for (k = 0; k < etaVals.size()-1; k++)
-    {
-
-       h_recbjet_cmis_pt = GetJetEffPt<Jet>(branchPFCJet, "CJet", 4, ptMin, ptMax, etaVals.at(k), etaVals.at(k+1), treeReaderCJet);
-       //h_recbjet_cmis_pt = GetEffPt<Jet>(branchPFCJet, branchParticleCJet, "CJet", 4, ptMin, ptMax, etaVals.at(k), etaVals.at(k+1), treeReaderCJet);
-       gr_recbjet_cmis_pt[k] = TGraphErrors(h_recbjet_cmis_pt);
-
-       s_etaMin = Form("%.1f",etaVals.at(k));
-       s_etaMax = Form("%.1f",etaVals.at(k+1));
-
-       s_eta = "c-jet , " + s_etaMin + " < | #eta | < "+s_etaMax;
-
-       gr_recbjet_cmis_pt[k].SetName("recEff_"+s_etaMin+"_"+s_etaMax);
-
-       addResoGraph(mg_recbjet_cmis_pt, &gr_recbjet_cmis_pt[k], leg_recbjet_cmis_pt, markerStyles.at(k), colors.at(k), s_eta);
-    }
-
-    // loop over pt
-    for (k = 0; k < ptVals.size(); k++)
-    {
-       h_recbjet_cmis_eta = GetJetEffEta<Jet>(branchPFCJet, "CJet", 4, 0.5*ptVals.at(k), 2.0*ptVals.at(k) ,etaMin, etaMax , treeReaderCJet);
-       //h_recbjet_cmis_eta = GetEffEta<Jet>(branchPFCJet, branchParticleCJet, "CJet", 4, 0.5*ptVals.at(k), 2.0*ptVals.at(k) ,etaMin, etaMax , treeReaderCJet);
-       gr_recbjet_cmis_eta[k] = TGraphErrors(h_recbjet_cmis_eta);
-
-       s_pt = Form("c-jet , p_{T} = %.0f GeV",ptVals.at(k));
-       if(ptVals.at(k) >= 1000.) s_pt = Form("c-jet , p_{T} = %.0f TeV",ptVals.at(k)/1000.);
-
-       addResoGraph(mg_recbjet_cmis_eta, &gr_recbjet_cmis_eta[k], leg_recbjet_cmis_eta, markerStyles.at(k), colors.at(k), s_pt );
-    }
-
-    TCanvas *c_recbjet_cmis_pt = new TCanvas("","", 800, 600);
-
-    mg_recbjet_cmis_pt->Draw("APE");
-    DrawAxis(mg_recbjet_cmis_pt, leg_recbjet_cmis_pt, ptMin, ptMax, 0.0, 20, "p_{T} [GeV]", "c - mistag rate (%)", true, false);
-    leg_recbjet_cmis_pt->Draw();
-    pave->Draw();
-
-    c_recbjet_cmis_pt->Print(pdfOutput,"pdf");
-    c_recbjet_cmis_pt->Print(figPath+"img_recbjet_cmis_pt.pdf","pdf");
-    c_recbjet_cmis_pt->Print(figPath+"img_recbjet_cmis_pt.png","png");
-
-    TCanvas *c_recbjet_cmis_eta = new TCanvas("","", 800, 600);
-
-    mg_recbjet_cmis_eta->Draw("APE");
-    DrawAxis(mg_recbjet_cmis_eta, leg_recbjet_cmis_eta, etaMin, etaMax, 0.0, 20, " #eta ", "c - mistag rate (%)", false, false);
-    leg_recbjet_cmis_eta->Draw();
-    pave->Draw();
-
-    c_recbjet_cmis_eta->Print(pdfOutput,"pdf");
-    c_recbjet_cmis_eta->Print(figPath+"img_recbjet_cmis_eta.pdf","pdf");
-    c_recbjet_cmis_eta->Print(figPath+"img_recbjet_cmis_eta.png","png");
-
-    // ------ light - mistag  ------
-
-    TMultiGraph *mg_recbjet_lmis_pt  = new TMultiGraph("","");
-    TMultiGraph *mg_recbjet_lmis_eta = new TMultiGraph("","");
-
-    TLegend *leg_recbjet_lmis_pt  = new TLegend(0.50,0.64,0.90,0.90);
-    TLegend *leg_recbjet_lmis_eta = new TLegend(0.50,0.64,0.90,0.90);
-
-    TGraphErrors *gr_recbjet_lmis_pt  = new TGraphErrors[n_etabins];
-    TGraphErrors *gr_recbjet_lmis_eta = new TGraphErrors[n_ptbins];
-    TH1D* h_recbjet_lmis_pt, *h_recbjet_lmis_eta;
-
-    // loop over eta bins
-    for (k = 0; k < etaVals.size()-1; k++)
-    {
-
-       h_recbjet_lmis_pt = GetJetEffPt<Jet>(branchJet, "Jet", 1, ptMin, ptMax, etaVals.at(k), etaVals.at(k+1), treeReaderJet);
-       //h_recbjet_lmis_pt = GetEffPt<Jet>(branchJet, branchParticleJet, "Jet", 1, ptMin, ptMax, etaVals.at(k), etaVals.at(k+1), treeReaderJet);
-       gr_recbjet_lmis_pt[k] = TGraphErrors(h_recbjet_lmis_pt);
-
-       s_etaMin = Form("%.1f",etaVals.at(k));
-       s_etaMax = Form("%.1f",etaVals.at(k+1));
-
-       s_eta = "uds-jet , " + s_etaMin + " < | #eta | < "+s_etaMax;
-
-       gr_recbjet_lmis_pt[k].SetName("recEff_"+s_etaMin+"_"+s_etaMax);
-
-       addResoGraph(mg_recbjet_lmis_pt, &gr_recbjet_lmis_pt[k], leg_recbjet_lmis_pt, markerStyles.at(k), colors.at(k), s_eta);
-    }
-
-    // loop over pt
-    for (k = 0; k < ptVals.size(); k++)
-    {
-       h_recbjet_lmis_eta = GetJetEffEta<Jet>(branchJet, "Jet", 1, 0.5*ptVals.at(k), 2.0*ptVals.at(k) ,etaMin, etaMax , treeReaderJet);
-       //h_recbjet_lmis_eta = GetEffEta<Jet>(branchJet, branchParticleJet, "Jet", 1, 0.5*ptVals.at(k), 2.0*ptVals.at(k) ,etaMin, etaMax , treeReaderJet);
-       gr_recbjet_lmis_eta[k] = TGraphErrors(h_recbjet_lmis_eta);
-
-       s_pt = Form("uds-jet , p_{T} = %.0f GeV",ptVals.at(k));
-       if(ptVals.at(k) >= 1000.) s_pt = Form("uds-jet , p_{T} = %.0f TeV",ptVals.at(k)/1000.);
-
-       addResoGraph(mg_recbjet_lmis_eta, &gr_recbjet_lmis_eta[k], leg_recbjet_lmis_eta, markerStyles.at(k), colors.at(k), s_pt );
-    }
-
-    TCanvas *c_recbjet_lmis_pt = new TCanvas("","", 800, 600);
-
-    mg_recbjet_lmis_pt->Draw("APE");
-    
-    DrawAxis(mg_recbjet_lmis_pt, leg_recbjet_lmis_pt, ptMin, ptMax, 0.0, 1.0, "p_{T} [GeV]", "light - mistag rate (%)", true, false);
-    
-    leg_recbjet_lmis_pt->Draw();
-    pave->Draw();
-
-    c_recbjet_lmis_pt->Print(pdfOutput,"pdf");
-    c_recbjet_lmis_pt->Print(figPath+"img_recbjet_lmis_pt.pdf","pdf");
-    c_recbjet_lmis_pt->Print(figPath+"img_recbjet_lmis_pt.png","png");
-
-    TCanvas *c_recbjet_lmis_eta = new TCanvas("","", 800, 600);
-
-    mg_recbjet_lmis_eta->Draw("APE");
-    DrawAxis(mg_recbjet_lmis_eta, leg_recbjet_lmis_eta, etaMin, etaMax, 0.0, 1.0, " #eta ", "light - mistag rate (%)", false, false);
-    leg_recbjet_lmis_eta->Draw();
-    pave->Draw();
-
-    c_recbjet_lmis_eta->Print(pdfOutput,"pdf");
-    c_recbjet_lmis_eta->Print(figPath+"img_recbjet_lmis_eta.pdf","pdf");
-    c_recbjet_lmis_eta->Print(figPath+"img_recbjet_lmis_eta.png","png");
-
-
-    ///////////////////////////////////////////
-    // tau-jets  Efficiency/ mistag rates   ///
-    ///////////////////////////////////////////
-
-    TMultiGraph *mg_rectaujet_eff_pt  = new TMultiGraph("","");
-    TMultiGraph *mg_rectaujet_eff_eta = new TMultiGraph("","");
-
-    TLegend *leg_rectaujet_eff_pt  = new TLegend(0.50,0.22,0.90,0.48);
-    TLegend *leg_rectaujet_eff_eta = new TLegend(0.50,0.22,0.90,0.48);
-
-    TGraphErrors *gr_rectaujet_eff_pt  = new TGraphErrors[n_etabins];
-    TGraphErrors *gr_rectaujet_eff_eta = new TGraphErrors[n_ptbins];
-    TH1D* h_rectaujet_eff_pt, *h_rectaujet_eff_eta;
-
-    // loop over eta bins
-    for (k = 0; k < etaVals.size()-1; k++)
-    {
-
-       h_rectaujet_eff_pt = GetTauEffPt<Jet>(branchPFTauJet, branchParticleTauJet, "TauJet", 15, ptMin, ptMax, etaVals.at(k), etaVals.at(k+1), treeReaderTauJet);
-       gr_rectaujet_eff_pt[k] = TGraphErrors(h_rectaujet_eff_pt);
-
-       s_etaMin = Form("%.1f",etaVals.at(k));
-       s_etaMax = Form("%.1f",etaVals.at(k+1));
-
-       s_eta = "#tau-jet , " + s_etaMin + " < | #eta | < "+s_etaMax;
-
-       gr_rectaujet_eff_pt[k].SetName("recEff_"+s_etaMin+"_"+s_etaMax);
-
-       addResoGraph(mg_rectaujet_eff_pt, &gr_rectaujet_eff_pt[k], leg_rectaujet_eff_pt, markerStyles.at(k), colors.at(k), s_eta);
-    }
-
-    // loop over pt
-    for (k = 0; k < ptVals.size(); k++)
-    {
-       h_rectaujet_eff_eta = GetTauEffEta<Jet>(branchPFTauJet, branchParticleTauJet, "TauJet", 15, 0.5*ptVals.at(k), 2.0*ptVals.at(k) ,etaMin, etaMax , treeReaderTauJet);
-       gr_rectaujet_eff_eta[k] = TGraphErrors(h_rectaujet_eff_eta);
-
-       s_pt = Form("#tau-jet , p_{T} = %.0f GeV",ptVals.at(k));
-       if(ptVals.at(k) >= 1000.) s_pt = Form("#tau-jet , p_{T} = %.0f TeV",ptVals.at(k)/1000.);
-
-       addResoGraph(mg_rectaujet_eff_eta, &gr_rectaujet_eff_eta[k], leg_rectaujet_eff_eta, markerStyles.at(k), colors.at(k), s_pt );
-    }
-
-
-    TCanvas *c_rectaujet_eff_pt = new TCanvas("","", 800, 600);
-
-    mg_rectaujet_eff_pt->Draw("APE");
-    DrawAxis(mg_rectaujet_eff_pt, leg_rectaujet_eff_pt, ptMin, ptMax, 0.0, 100, "p_{T} [GeV]", "#tau - tag efficiency (%)", true, false);
-    leg_rectaujet_eff_pt->Draw();
-    pave->Draw();
-
-    c_rectaujet_eff_pt->Print(pdfOutput,"pdf");
-    c_rectaujet_eff_pt->Print(figPath+"img_rectaujet_eff_pt.pdf","pdf");
-    c_rectaujet_eff_pt->Print(figPath+"img_rectaujet_eff_pt.png","png");
-
-    TCanvas *c_rectaujet_eff_eta = new TCanvas("","", 800, 600);
-
-    mg_rectaujet_eff_eta->Draw("APE");
-    DrawAxis(mg_rectaujet_eff_eta, leg_rectaujet_eff_eta, etaMin, etaMax, 0.0, 100., " #eta ", "#tau - tag efficiency (%)", false, false);
-    leg_rectaujet_eff_eta->Draw();
-    pave->Draw();
-
-    c_rectaujet_eff_eta->Print(pdfOutput,"pdf");
-    c_rectaujet_eff_eta->Print(figPath+"img_rectaujet_eff_eta.pdf","pdf");
-    c_rectaujet_eff_eta->Print(figPath+"img_rectaujet_eff_eta.png","png");
-
-
-    //--------------- tau mistag rate ----------
-
-    TMultiGraph *mg_rectaujet_mis_pt  = new TMultiGraph("","");
-    TMultiGraph *mg_rectaujet_mis_eta = new TMultiGraph("","");
-
-    TLegend *leg_rectaujet_mis_pt  = new TLegend(0.50,0.64,0.90,0.90);
-    TLegend *leg_rectaujet_mis_eta = new TLegend(0.50,0.64,0.90,0.90);
-
-    TGraphErrors *gr_rectaujet_mis_pt  = new TGraphErrors[n_etabins];
-    TGraphErrors *gr_rectaujet_mis_eta = new TGraphErrors[n_ptbins];
-    TH1D* h_rectaujet_mis_pt, *h_rectaujet_mis_eta;
-
-    // loop over eta bins
-    for (k = 0; k < etaVals.size()-1; k++)
-    {
-
-       h_rectaujet_mis_pt = GetTauEffPt<Jet>(branchJet, branchParticleJet, "TauJet", 1, ptMin, ptMax, etaVals.at(k), etaVals.at(k+1), treeReaderJet);
-       gr_rectaujet_mis_pt[k] = TGraphErrors(h_rectaujet_mis_pt);
-
-       s_etaMin = Form("%.1f",etaVals.at(k));
-       s_etaMax = Form("%.1f",etaVals.at(k+1));
-
-       s_eta = "uds-jet , " + s_etaMin + " < | #eta | < "+s_etaMax;
-
-       gr_rectaujet_mis_pt[k].SetName("recEff_"+s_etaMin+"_"+s_etaMax);
-
-       addResoGraph(mg_rectaujet_mis_pt, &gr_rectaujet_mis_pt[k], leg_rectaujet_mis_pt, markerStyles.at(k), colors.at(k), s_eta);
-    }
-
-    // loop over pt
-    for (k = 0; k < ptVals.size(); k++)
-    {
-       h_rectaujet_mis_eta = GetTauEffEta<Jet>(branchJet, branchParticleJet, "TauJet", 1, 0.5*ptVals.at(k), 2.0*ptVals.at(k) ,etaMin, etaMax , treeReaderJet);
-       gr_rectaujet_mis_eta[k] = TGraphErrors(h_rectaujet_mis_eta);
-
-       s_pt = Form("uds-jet , p_{T} = %.0f GeV",ptVals.at(k));
-       if(ptVals.at(k) >= 1000.) s_pt = Form("uds-jet , p_{T} = %.0f TeV",ptVals.at(k)/1000.);
-
-       addResoGraph(mg_rectaujet_mis_eta, &gr_rectaujet_mis_eta[k], leg_rectaujet_mis_eta, markerStyles.at(k), colors.at(k), s_pt );
-    }
-
-    TCanvas *c_rectaujet_mis_pt = new TCanvas("","", 800, 600);
-
-    mg_rectaujet_mis_pt->Draw("APE");
-    DrawAxis(mg_rectaujet_mis_pt, leg_rectaujet_mis_pt, ptMin, ptMax, 0.0, 5., "p_{T} [GeV]", "#tau - mistag(%)", true, false);
-    leg_rectaujet_mis_pt->Draw();
-    pave->Draw();
-
-    c_rectaujet_mis_pt->Print(pdfOutput,"pdf");
-    c_rectaujet_mis_pt->Print(figPath+"img_rectaujet_mis_pt.pdf","pdf");
-    c_rectaujet_mis_pt->Print(figPath+"img_rectaujet_mis_pt.png","png");
-
-    TCanvas *c_rectaujet_mis_eta = new TCanvas("","", 800, 600);
-
-    mg_rectaujet_mis_eta->Draw("APE");
-    DrawAxis(mg_rectaujet_mis_eta, leg_rectaujet_mis_eta, etaMin, etaMax, 0.0, 5., " #eta ", "#tau - mistag (%)", false, false);
-    leg_rectaujet_mis_eta->Draw();
-    pave->Draw();
-
-    c_rectaujet_mis_eta->Print(pdfOutput+")","pdf");
-    c_rectaujet_mis_eta->Print(figPath+"img_rectaujet_mis_eta.pdf","pdf");
-    c_rectaujet_mis_eta->Print(figPath+"img_rectaujet_mis_eta.png","png");
-
-
-//   ----   store resolution histograms in the output (for leave efficiencies out) ---
-
-
-  TFile *fout = new TFile(outputFile,"recreate");
-
-  for (int bin = 0; bin < Nbins; bin++)
-  {
-
-    for (k = 0; k < etaVals.size()-1; k++)
-    {
-       plots_trkpi_res_pt[k].at(bin).resolHist->Write();
-       plots_trkele_res_pt[k].at(bin).resolHist->Write();
-       plots_trkmu_res_pt[k].at(bin).resolHist->Write();
-       plots_ecal_res_e[k].at(bin).resolHist->Write();
-       plots_hcal_res_e[k].at(bin).resolHist->Write();
-       plots_pfele_res_e[k].at(bin).resolHist->Write();
-       plots_pfpi_res_e[k].at(bin).resolHist->Write();
-       plots_pfjet_res_e[k].at(bin).resolHist->Write();
-       plots_cajet_res_e[k].at(bin).resolHist->Write();
-
-    }
-
-    for (k = 0; k < ptVals.size(); k++)
-    {
-       plots_trkpi_res_eta[k].at(bin).resolHist->Write();
-       plots_trkele_res_eta[k].at(bin).resolHist->Write();
-       plots_trkmu_res_eta[k].at(bin).resolHist->Write();
-       plots_ecal_res_eta[k].at(bin).resolHist->Write();
-       plots_hcal_res_eta[k].at(bin).resolHist->Write();
-       plots_pfele_res_eta[k].at(bin).resolHist->Write();
-       plots_pfpi_res_eta[k].at(bin).resolHist->Write();
-       plots_pfjet_res_eta[k].at(bin).resolHist->Write();
-       plots_cajet_res_eta[k].at(bin).resolHist->Write();
-
+      plots_trkpi_res_eta[k].at(bin).resolHist->Write();
+      plots_trkele_res_eta[k].at(bin).resolHist->Write();
+      plots_trkmu_res_eta[k].at(bin).resolHist->Write();
+      plots_ecal_res_eta[k].at(bin).resolHist->Write();
+      plots_hcal_res_eta[k].at(bin).resolHist->Write();
+      plots_pfele_res_eta[k].at(bin).resolHist->Write();
+      plots_pfpi_res_eta[k].at(bin).resolHist->Write();
+      plots_pfjet_res_eta[k].at(bin).resolHist->Write();
+      plots_cajet_res_eta[k].at(bin).resolHist->Write();
     }
 
     plots_pfmet.at(bin).resolHist->Write();
     plots_camet.at(bin).resolHist->Write();
-
   }
 
   fout->Write();
-
 
   cout << "** Exiting..." << endl;
